
/////////////////////////////////////////////////////////////////////

extern void SetText (HWND hDlg, char *Txt)
{
	SendMessage(hDlg,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)Txt);
}

/////////////////////////////////////////////////////////////////////

extern char *GetText (HWND hDlg)
{
	static int StrCnt;
	static LPSTR StrFunc[16];
	static int T;
	static char Buffer[2048];
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	T=GetWindowTextLength(hDlg);
	GetWindowText(hDlg,Buffer,T+1);
	sprintf(StrFunc[StrCnt],"%s",Buffer);
	return StrFunc[StrCnt];
}

/////////////////////////////////////////////////////////////////////

extern void CenterWindow (HWND hWnd)
{
	static	RECT  wRect;
	static	DWORD  x;
	static	DWORD  y;
	GetWindowRect(hWnd,&wRect);
	x=(GetSystemMetrics(SM_CXSCREEN)-(wRect.right-wRect.left))/2;
	y=(GetSystemMetrics(SM_CYSCREEN)-(wRect.bottom-wRect.top+GetSystemMetrics(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

extern BOOL CheckReg(int Reg1, int Reg2, int Reg3)
{
	int LocalLoop = 0;
	while(LocalLoop < 1000)
	{
		if(Reg1 == RegArray1[LocalLoop] && Reg2 == RegArray2[LocalLoop] && Reg3 == RegArray3[LocalLoop] )
		{
			if(!WriteValidReg(Reg1,Reg2,Reg3))
				RegError();
			return TRUE;
		}
		LocalLoop++;
	}
	if(!WriteInvalidReg())
		RegError();
	return FALSE;
}

/////////////////////////////////////////////////////////////////////

extern BOOL WriteValidReg(int Reg1, int Reg2, int Reg3)
{
	if(!SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Reg1",Reg1))
		return FALSE;
	if(!SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Reg2",Reg2))
		return FALSE;
	if(!SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Reg3",Reg3))
		return FALSE;
	if(!SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Code",RegCode))
		return FALSE;
	if(!SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","Registered",1))
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////

extern BOOL WriteInvalidReg(void)
{
	if(!SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Reg1",0))
		return FALSE;
	if(!SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Reg2",0))
		return FALSE;
	if(!SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Reg3",0))
		return FALSE;
	if(!SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Code",0))
		return FALSE;
	if(!SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","Registered",0))
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////

extern void RegError(void)
{
	EndDialog(MainDialog_hWnd,0);
	MessageBox(MainDialog_hWnd, "128Gamma Registration Error!\r\n Please reinstall 128Gamma." ,TitleCaption,0 + MB_ICONEXCLAMATION);
	exit(0);
}

/////////////////////////////////////////////////////////////////////

