/*

 IncodeBuffer.H - Write Key , Write Key Length And Copy File To Temp

extern int IncodeBuffer(char *xSource, char *xTarget, char *Incode_Key)

*/

extern int IncodeBuffer(char *xSource, char *xTarget, char *Incode_Key)
{
	int SentSize = 0;

	DWORD SourceFileSize = 0;
	long double Current_Size = 0;

	SourceFileSize = FileSize(xSource);
	if(SourceFileSize == -1)
	{
		CancelFlag = TRUE;
		return 0;
	}


	FILE *Source;
	FILE *Target;

	if((Source = fopen(xSource,"rb")) == NULL)
	{
		Error("Could Not Open Source For Read. Error: 12.");
		if(Source)fclose(Source);
		return 0;
	}
	if((Target = fopen(xTarget,"wb")) == NULL)
	{
		Error("Could Not Open Temp File For Write. Error: 13.");
		if(Source)fclose(Source);
		if(Target)fclose(Target);
		return 0;
	}

	if(strlen(Incode_Key) < 10)
		fprintf(Target,"0");

	fprintf(Target,"%d",strlen(Incode_Key));
	fprintf(Target,"%s",Incode_Key);

	do
	{
		if(CancelFlag) // If User Clicks Cancel
		{
			if(Source)fclose(Source);
			if(Target)fclose(Target);
			CleanUp(0,1);
			return 0;
		}

		SentSize = fread(Buffer,sizeof(char),BufferSize,Source);
		fwrite(Buffer,sizeof(char),SentSize,Target);

		Current_Size += SentSize;
		StatusValue = (Current_Size / SourceFileSize) * 100;

	}
	while(SentSize == BufferSize);

	if(Source)fclose(Source);
	if(Target)fclose(Target);

	return 1;
}

