
/////////////////////////////////////////////////////////////////////

extern int CompressEncryptProcess(void)
{
	char xFile[257];
	char OutPutFile[257];
	float xFileSize = 0;
	char StatusTemp[1024];
	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,xFile,NULL);
	sprintf(OutPutFile,"%s.128",GlobalFileName);

	if(FAccess(OutPutFile,0))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = FileSize(GlobalFileName);
	if(xFileSize > MaxFileSize)
	{
		char StatusTemp[257];
		sprintf(StatusTemp,"128Gamma %s Cannot Encrypt File Larger Than %d MB.",ShortVersion,MaxFileSize/1024/1024);
		MessageBox (StatusDialog_hWnd, StatusTemp ,TitleCaption,0 + MB_SYSTEMMODAL);
		CleanUp(0,1);
		DoneFlag = 1;
		return(0);
	 }

	CleanUp(0,1);

	xFileSize = FileSize(GlobalFileName);
	sprintf(StatusTemp,"Compressing %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(Compress(GlobalFileName,CompressTemp))
	{
		xFileSize = FileSize(CompressTemp);
		sprintf(StatusTemp,"Buffering %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(IncodeBuffer(CompressTemp,EncryptTemp,CodedKey))
		{
			xFileSize = FileSize(EncryptTemp);
			sprintf(StatusTemp,"Encoding %.3f MB",xFileSize/1024/1024);
			Status = StatusTemp;

			if(IncodeMain(EncryptTemp,OutPutFile))
			{
				Status = "Data Successfully Encrypted!";
			}
		}
	}

	CleanUp(0,1);
	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;
	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int DecompressDecryptProcess(void)
{
	char OutPutFile[257];
	float xFileSize = 0;
	char StatusTemp[1024];
	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,OutPutFile,NULL);

	if(FAccess(OutPutFile,0))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = FileSize(GlobalFileName);
	sprintf(StatusTemp,"Decoding %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(DecodeMain(GlobalFileName,EncryptTemp))
	{
		xFileSize = FileSize(EncryptTemp);
		sprintf(StatusTemp,"Buffering %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(DecodeBuffer(EncryptTemp,CompressTemp,CodedKey))
		{
			xFileSize = FileSize(CompressTemp);
			sprintf(StatusTemp,"Decompressing %.3f MB",xFileSize/1024/1024);
			Status = StatusTemp;

			if(Decompress(CompressTemp,OutPutFile))
			{
				Status = "Data Successfully Decrypted!";
			}
		}
	}

	CleanUp(0,1);
	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

//////////////////////////////////////////////////////////////////////

extern int CompressPackProcess(void)
{
	char OutPutFile[1024];
	char StatusTemp[1024];
	float xFileSize = 0;

	CleanUp(0,1);
	sprintf(OutPutFile,"%s.128Pkg",GlobalFileName);

	if(FAccess(OutPutFile,0))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	if(PackFiles(GlobalFileName,PackTemp))
	{
		xFileSize = FileSize(PackTemp);
		sprintf(StatusTemp,"Compressing %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(Compress(PackTemp,CompressTemp))
		{
			xFileSize = FileSize(CompressTemp);
			sprintf(StatusTemp,"Buffering %.3f MB",xFileSize/1024/1024);
			Status = StatusTemp;

			/* EnCode(Source,Target,Password); */
			if(IncodeBuffer(CompressTemp,EncryptTemp,CodedKey))
			{

				xFileSize = FileSize(EncryptTemp);
				sprintf(StatusTemp,"Encoding %.3f MB",xFileSize/1024/1024);
				Status = StatusTemp;

				/* IncodeMain(Source,Target); */
				if(IncodeMain(EncryptTemp,OutPutFile))
				{
					Status = "Data Successfully Packed!";
				}
			}
		}
	}

	CleanUp(0,1);
	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

//////////////////////////////////////////////////////////////////////

extern int DecompressUnpackProcess(void)
{
	char OutPutFile[1024];
	char StatusTemp[1024];
	float xFileSize = 0;

	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,OutPutFile,NULL);

	if(FAccess(OutPutFile,0))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = FileSize(GlobalFileName);
	sprintf(StatusTemp,"Decoding %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(DecodeMain(GlobalFileName,EncryptTemp))
	{

		xFileSize = FileSize(EncryptTemp);
		sprintf(StatusTemp,"Buffering %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(DecodeBuffer(EncryptTemp,CompressTemp,CodedKey))
		{

			xFileSize = FileSize(CompressTemp);
			sprintf(StatusTemp,"Decompressing %.3f MB",xFileSize/1024/1024);
			Status = StatusTemp;

			if(Decompress(CompressTemp,PackTemp))
			{
				CreateDirectory(OutPutFile,0);

				if(UnPackFiles(PackTemp,OutPutFile))
				{
						Status = "Data Successfully Unpacked!";
				}
			}
		}
	}

	CleanUp(0,1);
	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////

extern int EncryptProcess(void)
{
	char xFile[257];
	char OutPutFile[257];
	float xFileSize = 0;
	char StatusTemp[1024];
	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,xFile,NULL);
	sprintf(OutPutFile,"%s.128",GlobalFileName);

	if(FAccess(OutPutFile,0))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = FileSize(GlobalFileName);
	if(xFileSize > MaxFileSize)
	{
		char StatusTemp[257];
		CleanUp(0,1);
		DoneFlag = 1;
		sprintf(StatusTemp,"128Gamma %s Cannot Encrypt File Larger Than %d MB.",ShortVersion,MaxFileSize/1024/1024);
		MessageBox (StatusDialog_hWnd, StatusTemp ,TitleCaption,0 + MB_SYSTEMMODAL);
		return(0);
	 }

	CleanUp(0,1);


	xFileSize = FileSize(GlobalFileName);
	sprintf(StatusTemp,"Buffering %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(IncodeBuffer(GlobalFileName,EncryptTemp,CodedKey))
	{
		xFileSize = FileSize(EncryptTemp);
		sprintf(StatusTemp,"Encoding %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(IncodeMain(EncryptTemp,OutPutFile))
		{
			Status = "Data Successfully Encrypted!";
		}
	}

	CleanUp(0,1);
	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;
	return(0);
}

/////////////////////////////////////////////////////////////////////

extern int DecryptProcess(void)
{
	char OutPutFile[257];
	float xFileSize = 0;
	char StatusTemp[1024];
	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,OutPutFile,NULL);

	if(FAccess(OutPutFile,0))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = FileSize(GlobalFileName);
	sprintf(StatusTemp,"Decoding %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(DecodeMain(GlobalFileName,EncryptTemp))
	{
		xFileSize = FileSize(EncryptTemp);
		sprintf(StatusTemp,"Buffering %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(DecodeBuffer(EncryptTemp,OutPutFile,CodedKey))
		{
			Status = "Data Successfully Decrypted!";
		}
	}

	CleanUp(0,1);
	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

//////////////////////////////////////////////////////////////////////

extern int PackProcess(void)
{
	char OutPutFile[1024];
	char StatusTemp[1024];
	float xFileSize = 0;

	CleanUp(0,1);
	sprintf(OutPutFile,"%s.128Pkg",GlobalFileName);

	if(FAccess(OutPutFile,0))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	if(PackFiles(GlobalFileName,PackTemp))
	{
		xFileSize = FileSize(PackTemp);
		sprintf(StatusTemp,"Buffering %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		/* EnCode(Source,Target,Password); */
		if(IncodeBuffer(PackTemp,EncryptTemp,CodedKey))
		{
			xFileSize = FileSize(EncryptTemp);
			sprintf(StatusTemp,"Encoding %.3f MB",xFileSize/1024/1024);
			Status = StatusTemp;

			/* IncodeMain(Source,Target); */
			if(IncodeMain(EncryptTemp,OutPutFile))
			{
				Status = "Data Successfully Packed!";
			}
		}
	}
	if(CancelFlag)
		unlink(OutPutFile);

	CleanUp(0,1);
	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

//////////////////////////////////////////////////////////////////////

extern int UnpackProcess(void)
{
	char OutPutFile[1024];
	char StatusTemp[1024];
	float xFileSize = 0;

	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,OutPutFile,NULL);

	if(FAccess(OutPutFile,0))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = FileSize(GlobalFileName);
	sprintf(StatusTemp,"Decoding %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(DecodeMain(GlobalFileName,EncryptTemp))
	{

		xFileSize = FileSize(EncryptTemp);
		sprintf(StatusTemp,"Buffering %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(DecodeBuffer(EncryptTemp,PackTemp,CodedKey))
		{
			CreateDirectory(OutPutFile,0);
			if(UnPackFiles(PackTemp,OutPutFile))
			{
					Status = "Data Successfully Unpacked!";
			}
		}
	}

	CleanUp(0,1);
	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

/////////////////////////////////////////////////////////////////////

